#!/usr/bin/env node

var deg = require('./index');
var helper = require('./lib/helper');

var config = require(process.cwd() + '/package.json').config;
var dwJson = require(process.cwd() + '/dw.json');

if (process.argv.includes('data')){
    if (config) {
        var { data } = config;
    }
    else {
        var data = {
            file_name: 'site-import',
            directories: [
                'site-import/'
            ]
        };
    }
    
    deg.archive('data', data.file_name, data.directories);        
}

if (process.argv.includes('code')) {
    var archiveName = dwJson.code_version || dwJson.version || 'version2';
    // console.log(`code version name: ${JSON.stringify(archiveName, null, 1)}`);

    var cartridges = helper.getCartridges();
    // console.log(`cartridge list: ${JSON.stringify(cartridges, null, 1)}`);

    helper.printIncludedCartridges(cartridges);
    
    deg.archive('code', archiveName, cartridges);
}